declare module BA.Ui.Duplicates {
    /** Events for DuplicateCheck Dialog */
    class DuplicateCheckDialogEvents {
        /**
         * Function that is executed, when the duplicates dialog is opened.
         * It performs a parametrized callback to the grid view in this dialog that displays the duplicates.
         *
         * @param popup the dialog being opened
         */
        static OnDialogOpen(popup: BA.Ui.Dialog.BADialogPopup): void;
        /**
         * Event function that is called, when the preview button of the duplicate dialog is clicked.
         * It shows the selected record in an orm dialog.
         *
         * @param button the button that has been clicked
         * @param evt the event parameters
         */
        static OnOpenButtonClick(button: BA.Ui.Dialog.BADialogButton, evt: any): void;
        /**
         * Event function that is called, when the switch-to button of the duplicate dialog is clicked.
         * It opens the selected record and closes the current one without dirty check.
         *
         * @param button the button that has been clicked
         * @param evt the event parameters
         */
        static OnSwitchButtonClick(button: BA.Ui.Dialog.BADialogButton, evt: ASPxClientButtonClickEventArgs): void;
        /**
         * Event function that is called, when the no-duplicate button of the duplicate dialog is clicked.
         * It calls a controller action in order to mark the current record and the selected record as "no duplicates".
         *
         * @param button the button that has been clicked
         * @param evt the event parameters
         */
        static NoDuplicateClick(button: BA.Ui.Dialog.BADialogButton, evt: ASPxClientButtonClickEventArgs): void;
    }
}
