declare module BA.Ui.TabController {
    class TabTools {
        private static tt_showtimeout;
        private static tt_hidetimeout;
        private static _WaitAnimationVisible;
        private static _WaitAnimationCounter;
        private static _WaitAnimationTimeout;
        private static _PreventNextEscTabClose;
        /**
         * Opens a new tab
         * @param url:                  The url: objectopen (or download)
         * @param asDirty:              Open the tab dirty? (Defaul: false)
         * @param overrideTabReference: Override the tab reference
         * @param tabOpenedCallback:    Callback function: executed only if a new tab was opened (will past the new tab)
         * @param forceTab:             Force to open in a Tab, even if called from a dialog
         */
        static OpenTab(url: string, asDirty?: Boolean, overrideTabReference?: string, tabOpenedCallback?: any, forceTab?: boolean): void;
        static PreventNextEscTabClose(): void;
        static UpdateLinks(): void;
        static ForceTabClose(): void;
        static HandleJsonFormResult(jsonFormResult: any): void;
        static ActivateTab(guid: any): void;
        static MarkTabAsLoaded(): void;
        static SetUrlForTab(url: any): void;
        static ReplaceUrlForTab(url: any): void;
        static SetReferenceForTab(ref: any): void;
        static SetDocumentOidForTab(oid: any): void;
        static UpdateDocumentPartsForTab(oid: any, keys: any): void;
        static WaitForTabLoaded(oid: string, maxRetries: number, callback: Function): boolean;
        static SetTabName(name: any): void;
        static SetTabIcon(icon: any): void;
        static GetTabName(): string;
        static SetTabAsDirty(tab: TabController.Tab): void;
        static SetTabAsDirtyByControl(control: ASPxClientControl): void;
        private static SetTabAsDirtyInternal;
        static GetTabIsDirty(guid?: string): boolean;
        static ExecuteAutoRefresh(): void;
        static SetTabAsClear(): void;
        static ClearAllTabs(): void;
        static SetTabAutorefreshForParent(autoRefresh: boolean): void;
        static SetTabAutorefresh(autoRefresh: boolean): void;
        static SetForcedTabAutorefresh(forcedAutoRefresh: boolean): void;
        static GetTabAutorefresh(): boolean;
        static GetForcedTabAutorefresh(): boolean;
        static ShowWaitAnimation(delayed?: boolean): void;
        static HideWaitAnimation(): void;
        static ShowInIFrameWaitAnimation(): void;
        static HideInIFrameWaitAnimation(): void;
        static ShowInputBlocker(): void;
        static HideInputBlocker(): void;
        static IsInputBlocked(): boolean;
        static SetTabAsCanClose(): void;
        static GetTabCanClose(guid?: string): boolean;
        static CloseAndOpenTab(url: any): void;
        /**
         * Close a tab
         * @param guid Optional parameter with the guid for the tab that has to be close
         */
        static CloseTab(guid: any): void;
        /**
        * Shows the tooltip
        * @param sender Hovered html element
        * @param event Event (for mouse position)
        */
        static ShowTooltip(sender: any, event: any): void;
        /**
        * Hides the tooltip, if visible
        * @param immediate Avoids to keep the tooltip for a short delay
        */
        static HideTooltip(immediate?: boolean): void;
        /**
         * Cancels a tooltip hide, what already started
         * @param sender The tooltip div
         */
        static CancelHideTootip(sender: any): void;
        /**
         * Cancels a tooltip show, what already started
         * @param sender The tooltip div
         */
        static CancelShowTootip(sender: any): void;
        private static KeydownHandler;
        private static SomethingInGridOpened;
        static AttachKeydownHandler(): void;
        static DetachKeydownHandler(): void;
        /**
         * Returns the hidden data of the currently opened dialog or of the tab form.
         */
        static GetCurrentFormHiddenData(control: ASPxClientControl): BA.Ui.Models.FormHiddenDataModel;
        /**
         * Returns the hidden data of the form
         */
        static GetFormHiddenData(): BA.Ui.Models.FormHiddenDataModel;
        /**
         * Returns the form name of the currently opened dialog or of the tab form.
         */
        static GetCurrentFormName(control: ASPxClientControl): string;
        static SetEditModeStatus(enabled: boolean): void;
        static GetEditModeStatus(): boolean;
        static SetMustSave(mustSave: boolean): void;
        static SetMustForceReadMode(force: boolean): void;
    }
}
